<script lang="ts">
import Vue from 'vue';
import { HorizontalScrollBar } from '../common/index.vue';

export default Vue.extend({
  components: {
    HorizontalScrollBar,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      progress: 0,
    };
  },
  mounted() {
    const { cards } = this.$refs;
    cards.$el.addEventListener(
      'scroll',

      function (e) {
        const { clientWidth } = e.target;
        const { scrollLeft } = e.target;
        const { scrollWidth } = e.target;

        const scrollPercent = scrollLeft / (scrollWidth - clientWidth);
        const scrollPercentRounded = Math.round(scrollPercent * 100);
        this.progress = scrollPercentRounded;
      }.bind(this),
    );
  },
});
</script>

<template>
  <SlpContainer>
    <SlpRow class="resources-block-container">
      <div class="resources-block__header">
        <SlpTypography tag="h2" variant="heading2">
          {{ data.header }}
        </SlpTypography>
        <SlpButton
          variant="tertiary"
          :href="data.link_url"
          :data-ga-name="data.data_ga_name"
          :data-ga-location="data.data_ga_location"
          >{{ data.link_text }}
          <SlpIcon
            class="slp-ml-8"
            name="chevron-lg-right"
            variant="product"
            alt="Chevron Right Icon"
            hex-color="#171321"
          />
        </SlpButton>
      </div>
      <hr class="resources-block__line" />
    </SlpRow>
    <SlpRow ref="cards" class="cards-container">
      <SlpColumn
        v-for="(card, index) in data.cards"
        :key="index"
        :cols="data.column_size"
        class="slp-mb-48 resource-card"
      >
        <a
          :href="card.href"
          class="resources-block"
          :data-ga-name="card.data_ga_name"
          :data-ga-location="card.data_ga_location"
        >
          <div class="resources-block__wrapper">
            <div class="resources-block__content-top">
              <div class="resources-block__icon slp-flex">
                <nuxt-img
                  class="icon"
                  :src="card.icon"
                  alt=""
                  loading="lazy"
                  format="webp"
                  quality="99"
                />
                <SlpTypography
                  tag="p"
                  variant="body2"
                  class="resources-block__type"
                  >{{ card.event_type }}</SlpTypography
                >
              </div>
              <div class="resources-block__image-container">
                <nuxt-img
                  class="resources-block__image slp-my-24"
                  :src="card.image"
                  alt=""
                  loading="lazy"
                  format="webp"
                  quality="99"
                />
              </div>
              <SlpTypography tag="h3" variant="body1" class="">{{
                card.header
              }}</SlpTypography>
            </div>
            <div class="resources-block__content-bottom">
              <SlpTypography
                variant="button"
                tag="span"
                class="resources-block__link"
                >{{ card.link_text }}
                <SlpIcon
                  class="slp-ml-8"
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
                  hex-color="#171321"
                />
              </SlpTypography>
            </div>
          </div>
        </a>
      </SlpColumn>
    </SlpRow>
    <HorizontalScrollBar class="horizontal-scroll" :value="progress" />
  </SlpContainer>
</template>

<style scoped lang="scss">
.horizontal-scroll {
  display: none;

  @media (max-width: 560px) {
    display: block;
  }
}

.resources-block-container {
  margin: $spacing-96 auto 0 auto;

  @media (max-width: 560px) {
    margin: $spacing-96 auto 0 auto;
  }
}

.cards-container {
  scrollbar-width: none; // hides scrollbar on Firefox
  -ms-overflow-style: none; // hides scrollbar on IE 10+

  &::-webkit-scrollbar {
    // hides scrollbar on browsers that use that use Webkit (Chrome, Safari, Opera, etc)
    width: 0;
    height: 0;
    display: none;
  }

  @media (max-width: 560px) {
    margin-bottom: $spacing-16;
    flex-wrap: nowrap;
    overflow-x: auto;

    .resource-card {
      min-width: 270px;
      margin-right: $spacing-16;
      margin-bottom: 40px;
      margin-top: 60px;
    }
  }
}

.resources-block__header {
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;

  h2 {
    font-weight: $font-weight-bold;
  }
}

.resources-block__line {
  margin: $spacing-32 0 $spacing-16 0;
  border-top: 1px solid $color-surface-400;
  border-bottom: 0;
  border-left: 0;
  border-right: 0;
  width: 100%;
}

.slp-btn {
  color: $color-text-300;
}

.slp-text-button,
.slp-btn-ghost {
  font-weight: 600;
}

.slp-btn svg,
.resources-block__link svg {
  vertical-align: middle;
  margin-left: $spacing-4;
}

.resources-block {
  cursor: pointer;
  display: flex;
  position: relative;
  height: 100%;

  @media (min-width: $breakpoint-md) {
    margin: $spacing-16 $spacing-16 $spacing-16 0;
  }

  &__wrapper {
    display: flex;
    flex-direction: column;
    transition: all 0.3s ease-in-out;
    justify-content: space-between;
    padding: $spacing-32 $spacing-16;
    flex: 1;

    @media (max-width: 560px) {
      background: $color-surface-800;
    }

    &:hover {
      background: $color-surface-800;
      border-radius: 0 0 100px 0;
    }

    .resources-block__image-container {
      position: relative;

      .resources-block__image {
        width: 100%;
      }
    }
  }

  &__link {
    display: flex;
    align-items: center;
    line-height: 22px;
    color: $color-text-300;
    padding-left: 0;

    @media (max-width: 560px) {
      margin-top: 44px;
    }
  }

  &__type {
    margin-left: $spacing-8;
  }

  &__content-top {
    p,
    h3 {
      color: $color-text-300;
    }
  }

  &__icon {
    align-items: center;

    .icon {
      max-width: 24px;
      max-height: 24px;
    }
  }
}
</style>
